<?php if (!defined('PmWiki')) exit();
// See precode/README
if (file_exists("cookbook/precode/precode.php")) {
  $EnablePrecode = 1;
  include_once('cookbook/precode/precode.php');
}

function PreCode2($pagename, $text, $args = '') {

	global $HTMLHeaderFmt, $HTMLFooterFmt, $HTMLStylesFmt, $cbInstallDir;
	$PreCode = _PreCode($pagename, $text, $args);
	extract($PreCode, EXTR_OVERWRITE);

	/////// ADJUST VALUES ///////

	include_once '../../../pub/lib/geshi/1.0.8.10/geshi.php'; # include geshi

	/////////////////////////////

	$lang = trim($lang);
	if(isset($lang) && ! empty($lang) ) { $language = $lang; }

	if(isset($language)) {

		$text = str_replace(array('<:vspace>', '&lt;', '&gt;', '&amp;'),
				array('', '<', '>', '&'), $text);

		if($language === 'html') { $lang = $language = 'html4strict'; }
		$geshi = new GeSHi($text, $language);
		$geshi->enable_keyword_links(false);
		$geshi->set_header_type(GESHI_HEADER_NONE);
		$geshi->enable_classes();
		$styles = $geshi->get_stylesheet();

		$text = $geshi->parse_code();
		$text = str_replace(array('<br>','<br />'), '', $text);

		$HTMLStylesFmt['GeSHi_'.$language] =  $styles;

	}

	static $highlights = array();
	include("$cbInstallDir/precode/adapter/adapter.base.php");

	$_id = " id='$id'"; $_idc = " id='$idc'";
	$_c = isset($args['classreset']) ? $args['classreset'].$args['_c'] : '';
	$_c1 = ' class="'.$args['theme'].$showlines.' hs '.$args['classreset'].'"';
	$_c2 = ' class="'.$lang.' '.$_c.'"';
	return Keep('<style>'.$styles.'</style><pre'.$_id.$_c1.'><code'.$_idc.$_c2.'>'.$text.'</code></pre>');

}

