<?php if(!defined('PmWiki'))exit;

include_once("$cbInstallDir/qnotes/scripts/functions.php");

/*
 * Create HomePage if not exist
 * ----------------------------
 */
$HomePage = $pn = $Config['page']['CurrentGroup'] . '/HomePage';
$g = $Config['page']['CurrentGroup'];
if( ! PageExists($pn) && $g !== '' && $g !== 'Templates') {
  if(trim(MakePageName($pagename, $pn)) !== '') {
    $new = RetrieveAuthPage('Templates.HomePageInclude', 'read', 0);
    PostPage($pn, $new, $new);
    //PostRecentChanges($pn, $new, $new);
    if('HomePage' == $Config['page']['CurrentName']) { Redirect($pn); }
  }
}

/*
 * Create QMgr page if not exist
 * ------------------------------
 */
$QMgr = $pn = $Config['page']['CurrentGroup'] . '/QMgr';
$g = $Config['page']['CurrentGroup'];
if( ! PageExists($pn) && $g !== '' && $g !== 'Templates' && $pagename == $pn) {
  if(trim(MakePageName($pagename, $pn)) !== '') {
    $new = RetrieveAuthPage('Templates.QMgrInclude', 'read', 0);
    PostPage($pn, $new, $new);
    PostRecentChanges($pn, $new, $new);
    Redirect($pn.'?'.$_SERVER['QUERY_STRING']);
  }
}

/*
 * Load Name css
 * -----------------
 */
SDV($PageCSSListFmt,array(
  'pub/css/local.css' => '$PubDirUrl/css/local.css',
  'pub/css/{$Group}.css' => '$PubDirUrl/css/{$Group}.css',
  'pub/css/_{$Name}.css' => '$PubDirUrl/css/_{$Name}.css',
  'pub/css/{$FullName}.css' => '$PubDirUrl/css/{$FullName}.css'
));

/*
 * Load Name js
 * -----------------
 */
SDV($PageJSListFmt,array(
  'pub/js/local.js' => '$PubDirUrl/js/local.js',
  'pub/js/{$Group}.js' => '$PubDirUrl/js/{$Group}.js',
  'pub/js/_{$Name}.js' => '$PubDirUrl/js/_{$Name}.js',
  'pub/js/{$FullName}.js' => '$PubDirUrl/js/{$FullName}.js'
));
foreach((array)$PageJSListFmt as $k=>$v)
  if (file_exists($f = FmtPageName($k,$pagename))) 
    $HTMLFooterFmt[$f] = "\n<script type='text/javascript' src='$v'></script>";

/*
 * Load Name php
 * -----------------
 */
SDV($PagePhp2ListFmt,array(
  'local/_{$Name}.php' => '$LocalDir/_{$Name}.php'
));
foreach((array)$PagePhp2ListFmt as $k=>$v) {
  if (IsEnabled($EnablePGCust,1) && file_exists($f = FmtPageName($k,$pagename))) 
    include_once($f);
}


