<?php if (!defined('PmWiki')) exit();

$RecipeInfo['syntaxlove']['Version']='2013-03-02';

if (!isset($syntax_style)) {
 $syntax_style = "shThemeDefault.css";
}
$syntax_path_js = "/pub/lib/syntaxhighlighter/3.0.83/scripts";
$syntax_path_css = "/pub/lib/syntaxhighlighter/3.0.83/styles";

//Note: combine XRegExp.js + shCore.js into single file => shCore.js
$HTMLFooterFmt[] =
  "\n<script type='text/javascript' src='$syntax_path_js/shCore.js'></script>";

foreach ($Array_Syntaxlove as $key => $value){
  switch ($value){
    case "1": $HTMLFooterFmt[] = "<script type='text/javascript' src='$syntax_path_js/shBrush$key.js'></script>";
  }
}

$HTMLHeaderFmt[] = "\n
  <link type='text/css' rel='stylesheet' href='$syntax_path_css/shCore.css'/>
  <link type='text/css' rel='stylesheet' href='$syntax_path_css/$syntax_style'/>
";

$HTMLFooterFmt[] = "\n
  <script type='text/javascript'>
    SyntaxHighlighter.all();
  </script>";

# this functions activates the options
function syntaxlove_options($options) {
    $class = '';
    $params = array('html'     => 'html-script',      'lightmode' => 'light',      'wrap'       => 'wrap-lines',
                    'gutter'   => 'gutter',           'ruler'     => 'ruler',      'toolbar'    => 'toolbar',
                    'collapse' => 'collapse',         'autolinks' => 'auto-links', 'smarttabs'  => 'smart-tabs',
                    'pad'      => 'pad-line-numbers', 'title'     => 'title',      'firstline'  => 'first-line',
                    'highlight'=> 'highlight',        'tabsize'   => 'tab-size');

    #look to see if the code option has been specified, if not, resort to 'plain' formatting
    $brush = 'plain';
    if(preg_match("/([^ ](\w*)[^= ])/esi",$options,$matches)) {
        $brush = $matches[0];
        foreach($params as $k => $v) {
            if(preg_match("/$k/i", $matches[0], $match)){
                $brush = 'plain';
            }
        }
    }
    $class .= "brush:'".$brush."';";

    #Find options and format them for html
    foreach ($params as $key => $value) {
        if (preg_match("/($key='.*?')/esi", $options,$matches)) {
            $class .= str_replace("$key=", "$value:", $matches[0]).";";
        }
    }
    return ($class);
}


Markup('code',
    '<fulltext',
    '/\\(:codestart(.*?):\\)(.*?)\\(:codeend:\\)/esi',
    "'<:block>'.Keep(str_replace(array(),
    array(), PSS('<pre class=\"'.syntaxlove_options('$1').'\">'.'$2'.'</pre>')))");
