<?php
$DefaultName = 'HomePage';
$WikiTitle = 'Notebook';
$EnablePathInfo = 1;
//$HTMLPNewline = '<br/>';
$DiffKeepDays=2;  # keep page history at least 2 day

## Get wiki group and pagename for use
$_t = FmtPageName('$Group', $pagename);
$Config['page']['CurrentGroup'] = $_t ? $_t : $DefaultGroup;
$_t = FmtPageName('$Name', $pagename);
$Config['page']['CurrentName'] = $_t ? $_t : $DefaultName;

if($pagename == '') {
  Redirect($Config['page']['CurrentGroup'].'/'.$Config['page']['CurrentName']);
}

$UploadPrefixFmt = '/$Group/$Name';
$EnableDirectDownload = 1;
$UploadMaxSize = 2*1024*1024; #2Mb
$UploadDirQuota = 25*1024*1024; # limit uploads to 25MB
$EnableUpload = 1;
$FmtPV['$AttachCount'] = 'AttachExist("$group.$name")';

  $DefaultPasswords['admin'] = '$1$n3X8jFK1$LsZO6vmMO1kYjZlTNlYKi0';
  $DefaultPasswords['upload'] = '$1$QnVcPh3X$QiY/WoX6tkbS1gBT/UNTG0';
  $DefaultPasswords['edit'] = '$1$RQ1Yg.xX$vkbvBDI.3ia.fwuuSK2tC0';
  $DefaultPasswords['attr'] = '$1$RQ1Yg.xX$vkbvBDI.3ia.fwuuSK2tC0';

  $EnablePageStoreXML = 1;
  include_once("$cbInstallDir/XMLPageStore.php");
  $WikiDir = new XMLPageStore('wiki.d/{$FullName}');

$WikiLibDirs = array(
     &$WikiDir,
     new XMLPageStore('wikilib.ext.d/{$FullName}'),
     new PageStore('wikilib.d/{$FullName}'),
     new PageStore('$FarmD/wikilib.d/{$FullName}')
);

$GroupHeaderFmt = '(:include {$SiteGroup}.SiteHeader self=0 basepage={*$FullName}:)(:include {$Group}.GroupHeader self=0 basepage={*$FullName}:)(:nl:)';
$GroupFooterFmt = '(:nl:)(:include {$SiteGroup}.SiteFooter self=0 basepage={*$FullName}:)(:include {$Group}.GroupFooter self=0 basepage={*$FullName}:)';

$HandleAuth['diff'] = 'edit';

//custom skin libdirs
SDV($SkinLibDirs, array(
    $ConfigAll['current']['application']['install']['path']."/pub/skins/\$Skin" => "$PubDirUrl/skins/\$Skin",
    $ConfigAll['apps']['pmwiki']['path']."/pub/skins/\$Skin" => "$FarmPubDirUrl/skins/\$Skin",
));
#print_r($SkinLibDirs); exit;
$Skin = 'pmwiki-dt';
//$Skin = 'pmwiki';

function IsAjaxRequest() {
  $isXmlHttpRequest =
      array_key_exists('X_REQUESTED_WITH', $_SERVER) &&
      strtolower($_SERVER['X_REQUESTED_WITH']) == 'xmlhttprequest';
  $isAjax =
      array_key_exists('HTTP_AJAX', $_SERVER) &&
      $_SERVER['HTTP_AJAX'] == 'true';
  if ($isXmlHttpRequest || $isAjax) { return true; }
  return false;
}
if(IsAjaxRequest()) {
  $Skin = 'qnote';
  if($action == 'logout') {
    $r = '?qnp=Site.Admin&qn=/login&async=1&qfmt=html&action=qnotes';
    $LogoutRedirectFmt = '$FullName'.$r;
  }
}

// ------------------------------------------------------
// Common cookbook
// ------------------------------------------------------
include_once('cookbook/cookbook-common.php');
include_once('cookbook/default.php'); //other recipes + settings
// ------------------------------------------------------

// ============  Notebook ============
include_once('cookbook/notebook.php');



if ($action !== 'edit') {
    SetTmplDisplay('PageHeaderFmt', 0);
    SetTmplDisplay('PageTitleFmt', 0);
    SetTmplDisplay('PageActionFmt', 0);
    SetTmplDisplay('PageLeftFmt', 0);
    SetTmplDisplay('PageFooterFmt', 0);
}
if ($action == 'edit') {
    SetTmplDisplay('PageLeftFmt', 0);
}
if ($action == 'search') {
    SetTmplDisplay('PageTitleFmt', 1);
    SetTmplDisplay('PageActionFmt', 1);
}


//     if(isset($_SESSION['qnotesOPN']) && $_SESSION['qnotesOPN'] !== '') {
//       $FmtPV['$qnotesOPN'] = '$_SESSION["qnotesOPN"]';
//       $FmtPV['$qnotesOPNGroup'] =  FmtPageName('$Group', $_SESSION["qnotesOPN"]);
//     }
