/*<![CDATA[*/
var Ready1 = function() {
  if(typeof Qnotes.ViewBox.mousedowns == 'undefined') {
    Qnotes.ViewBox.mousedowns = [];
  }
  if(typeof Qnotes.Init.qnoteext == 'undefined') {
    Qnotes.Init.qnoteext = [];
  }
  $(qnotesBox).relayEvent("mousedown", ".login > a", $(qnotesBox).LoginLink);
  $(qnotesBox).relayEvent("mousedown", ".phplmnormal li", phplmList);
  $(qnotesBox).relayEvent("mousedown", ".phplmnormal a", qnotelink);
  $(qnotesBox).relayEvent("mousedown", ".qnotesList a", qnotelink);

  QnFrmCls = function(e) {
    Qnotes.item.triggerEvent("mousedown"); return false;
  }
  $(qnotesEF).removeEvent("mousedown");
  $(qnotesEF).relayEvent("mousedown", "#qnotesFrmClose", QnFrmCls);

  Dirlist = function (e) {
    obj = $(e.target);
    var p = new Poly9.URLParser(Qnotes.Url.decode('1', obj.href));
    q = p.getQueryarray();
    if (q.f !== undefined) { obj.target = '_blank'; return true; }
    obj.onclick = function() { return false; }
    
    url = qnscripturl+"?n="+qncurpgn+"&qn="+qncategory+"&qnp="+qnpagename+"&dir="+q.dir;
    Qnotes.item.title = qncategory+'/dirlist+/'+Qnotes.Url.decode('1', q.dir, 1);
    Qnotes.item.href = url;
    Qnotes.item.triggerEvent("mousedown");
  }
  $(qnotesBox).relayEvent("mousedown", "div.dirlist .list a", Dirlist);
  $(qnotesBox).relayEvent("mousedown", "div.dirlist .path a", Dirlist);
  
  MiniboxInit = function () {
    minilinks = $(qnotesBox).elmsByAttribute('class', 'minilink', 'a');
    if(minilinks.length > 0) { LB={}; _.Ui(minilinks); }
  }
  
  PreCode = function () {
    //numx = $(qnotesBox).cssSelect('pre .numx');
    //if(typeof numx == 'object' && numx.length > 0) { return; }
    pres = $(qnotesBox).elmsByTag('pre');
    var PRECODE_CONFIG = {"nodes" : pres};
    Precode.Setlinenum(PRECODE_CONFIG);
  }
  PreCodeH = function () {
    var hgs2 = []; Precode.Highlight(hgs2);
    //jQuery(document).unbind('keydown');
    jQuery(pres).CodePresenter();
  }
  Hljs = function () {
    codes = $(qnotesBox).elmsByTag('pre code');
    if(codes.length < 0) { return; }
    codes.each( function(elm, idx, set) { hljs.highlightBlock(elm); });
  }
  Prettify = function () {
    //to remove current title's having class 'prettyprint'
    prettyPrint();
  }

  SortTblInit = function () {
    tbls = $(qnotesBox).elmsByTag('table');
    if(!tbls) { return; }
    for (ti=0;ti<tbls.length;ti++) {
      thisTbl = tbls[ti];
      if (((' '+thisTbl.className+' ').indexOf("sortable") != -1) && (thisTbl.id)) {
        ts_makeSortable(thisTbl);
      }
    }
  }
  TblSortInit = function () {
    tbls = $(qnotesBox).elmsByTag('table');
    if(tbls.length > 0) {
      tbls.first().id = 'dirlist2'; t = tbls.first();
      if(t.hasClass('sortable') || t.hasClass('todo-form') || t.hasClass('todo-list') ) { return; }
      new Tablesort(document.getElementById('dirlist2'));
    }
    return;
  }
  ListJs = function () {
    dl = $(qnotesBox).elmsByAttribute('class', 'dirlist', 'div');
    vp = Qnotes.ViewPane.pos['vp0']; n = round(vp.height/29);
    if (vp.width <= 400) { n = n-8 }
    if(dl.length > 0) {
      dl.first().id = 'qdirlist';
      var fuzzyOptions = {
        searchClass: "search-fuzzy", location: 0, distance: 100,
        threshold: 0.4, multiSearch: true
      };
      var pagingOptions = {
        pagingClass: "topPaging", innerWindow: 1, left: 1, right: 1 }
      var options = {
        valueNames: [ 'f', 's', 't' ],
        page: n,
        plugins: [
          [ 'paging', pagingOptions ],
          //[ 'fuzzySearch', fuzzyOptions ]
        ]
      };
      fuz = $(qnotesBox).elmsByAttribute('class', 'search-fuzzy', 'input');
      fuz.addClass('search');
      var dirlst = new List('qdirlist', options);
      //fuz.first().onkeyup = function(e) { dirlst.fuzzySearch(this.value); };
    }
  }

  VSToDoNotes = function (e) {
    obj = e.target; if(obj.tagName !== 'LI') { return; }
    if(VSToDo.frm) str1 = VSToDo.frm['todoform'].value;

    a = $(obj).elmsByTag('a.tododelete').first(); if(!a) return;
    var p = new Poly9.URLParser(Qnotes.Url.decode('1', a.href));
    q = p.getQueryarray();

    ds = q.todoitem.substr(0,8); time=q.todoitem.substr(8,4);
    sec=''; hash = q.todoitem.substr(12,32);
    qnp = 'Todo.'+str1.ucfirst(); qn = '/'+ds+'/'+time+sec+hash;
    Qnotes.item.href = qnscripturl+"?n="+qncurpgn+"&qn="+qn+"&qnp="+qnp;
    Qnotes.item.title = qn; //Qnotes.item.fetchmode = 'async';
    Qnotes.Url.fmt = 1; Qnotes.item.triggerEvent("mousedown");
    return false;
  }
  VSToDoAdd = function (toFrm) {
    if(typeof VSToDo == 'undefined') { VSToDo = {}; }
    VSToDo.frm = toFrm; if(isQNL()) { return; }

    VSToDo.dels = $(qnotesBox).cssSelect('.simpletodo li > del');
    VSToDo.dels.each(function(elm, idx, set) { $(elm.parentNode).addClass('done'); });
    
    toFrm.tododata.focus();
    if(typeof VSToDo.listInit == 'undefined') {
      $(qnotesBox).relayEvent("mouseup", "ul > li", VSToDoNotes);
      VSToDo.listInit = 1;
    }
    toFrm.setAJAXForm(
      function() {
        str = toFrm['tododata'].value; if(str.trim() == '') { return false; }
        list = toFrm['todoform'].value; str1 = list.trim()+str.trim();
        Qnotes.Loading.show(); toFrm['n'].value = qnpagename;
        var d = new Date(); VSToDo.t1 = getLocalDateStamp(d.getTime(), 2).toString();
        toFrm.addContent("<input type=hidden name='datestamp' value='"+VSToDo.t1+"'/>");
        if(typeof MD5 == 'function') {
	  VSToDo.hash = VSToDo.t1.substr(0,12)+MD5(str1).toString()+'-'+list; }
      }, function(rdata) {
        if($(qnotesBox).IsAuthReqired(rdata)) { return false; }
        if(AsyncSuccess(rdata, 'Done...')) {
          if(typeof MD5 == 'function') { VSToDoMakeNewItem(str);
            ul = $(qnotesBox).elmsByTag('ul').first();
            if(ul) { $(ul).addContent(VSToDo.new); } else { RALD(1, 500); }
          }
          toFrm['tododata'].value = '';
          if(typeof MD5 !== 'function') { RALD(1, 500); }
            else { UpdateQNT(qnpagename, Qnotes.item.title, 100); }
        }
        return false;
      });
    toFrm.onsubmit = function() { return false; }
  }
  VSToDoMakeNewItem = function (str) {
    hash = VSToDo.hash;
    newtodo = "<a class='tododelete'"+" href='"+qnscripturl+"?n="+qnpagename
                   +"&todoitem={{hash}}&action=todo-delete'>delete</a>";
    newtodo = newtodo.replace("{{hash}}", hash);
    newtodo2 = newtodo.replace(/delete/g, 'done');
    VSToDo.new = '<li>' + str + ' ' + newtodo + '&nbsp;' + newtodo2 + '</li>';
  }
  VSToDoItem = function (e) {
    obj = o2 = e.target; obj.onclick = function() { return false; }
    if(obj.tagName == 'LI' || isQNL()) { return; }
    
    list = VSToDo.frm['todoform'].value;
    var p = new Poly9.URLParser(Qnotes.Url.decode('1', o2.href));
    q = p.getQueryarray();
    qn = qncategory; qnp = qnpagename;
    url = qnscripturl+"?n="+qnpagename+"&qn="+qn+"&qnp="+qnp
           +"&todoitem="+q.todoitem+"&action="+q.action;

    li = $(obj.parentNode); text = $(obj.parentNode.firstChild);
    str = text.innerText || text.textContent;
  
    change = function(obj) {
     if($(obj).hasClass('todoundo')) { text.replace(str);
       cl='tododone'; from='todo-undo'; to='todo-done'; txt='done'; li.removeClass('done');
     } else { text.replace('<del>'+str+'</del>');
       cl='todoundo'; from='todo-done'; to='todo-undo'; txt='undo'; li.addClass('done');
     }
     $(obj).className = cl; obj.innerHTML = txt; obj.href = obj.href.replace(from, to);
    }
    $(qnotesBox).get(url, function(rdata) {
      if($(qnotesBox).IsAuthReqired(rdata)) { return false; }
      if(rdata.indexOf('Done...') != -1) {
        if( $(obj).hasClass('todoundo') || $(obj).hasClass('tododone') ) { change(obj); }
        if($(obj).hasClass('tododelete')) { li.remove();
          qnp = 'Todo.'+list.ucfirst(); qn = '/'+q.todoitem;
          n = Qnotes.Init.getnode(qnp, qn, 'node'); if(n) { n.remove(); }
        }
        if( $(obj).hasClass('todoclean') ) {
          del = $(qnotesBox).elmsByTag('ul > li del');
          del.each(function(elm, idx, set) { $(elm.parentNode).remove(); });
        }
        UpdateQNT(qnpagename, Qnotes.item.title, 100);
      }
    });
    return false;
  }
  $(qnotesBox).relayEvent("mouseup", ".todoundo", VSToDoItem);
  $(qnotesBox).relayEvent("mouseup", ".tododelete", VSToDoItem);
  $(qnotesBox).relayEvent("mouseup", ".tododone", VSToDoItem);
  $(qnotesBox).relayEvent("mouseup", ".todoclean", VSToDoItem);
  
  ToDoFrm = function(toFrm) {
    toFrm.setAJAXForm(
      function(){
        Qnotes.Loading.show();
        update = toFrm.action +"&n="+qncurpgn+'&qnp=none&qn=/none&async=1';
        create = qnscripturl+"?n="+qncurpgn+'&action=todo&do=create-todo-item';
        if ((' '+toFrm.action+' ').indexOf("do=create") != -1) {
          toFrm.action = create; } else { toFrm.action = update; }
        toFrm['todo-next-page'].value = qnscripturl+"?n="+qncurpgn+'&qnp=none&qn=/none&async=1';
      }, function(rdata) {
        if (AsyncSuccess(rdata)) { RALD(1, 300, 'lnode'); }
        return false;
      });
    toFrm.onsubmit = function() { return false; }
  }
  ToDoList = function(e) {
    obj = o2 = $(e.target);
    if ((' '+obj.href+' ').indexOf("do=edit") == -1) { return; }
    o2.onclick = function() { return false; }

    qnp = qnpagename; qn = '/none';
    Qnotes.item.href =  obj.href = obj.href+"&n="+qncurpgn+"&qnp="+qnp+"&qn="+qn;
    Qnotes.item.title = qncategory+'/update+';

    if(n = Qnotes.Init.getnode(qnp, Qnotes.item.title, 'node')) n.remove();
    Qnotes.Url.fmt = 2; Qnotes.item.fetchmode = 'async';
    Qnotes.item.triggerEvent("mousedown");
  }
  $(qnotesBox).relayEvent("mousedown", ".todo-list a", ToDoList);
  $(qnotesBox).relayEvent("mousedown", ".todo-simple-list td a", ToDoList);
  
  ToDoListJs = function () {
    tbl = $(qnotesBox).cssSelect('#todolist .todo-list');
    if(tbl.length < 1) { return; }
    thNames = ['ID','Priority','Urgency','PU','Status','Created','Due','Completed'];
    th = tbl.first().elmsByTag('th');
    th.each( function(elm, idx, set) {
      $(elm).addClass('sort');
      $(elm).setAttribute("data-sort", thNames[idx]);
    });
    tbl2 = $(qnotesBox).cssSelect('#todolist table.list2');
    if(tbl2.length < 1) { return; }
    tr = tbl2.first().elmsByTag('tr');
    tr.each( function(elm, idx, set) {
      td = $(elm).elmsByTag('td');
      td.each( function(elm2, idx2, set2) {
        $(elm2).addClass(thNames[idx2]);
      });
    });
    tbody = tbl2.first().cssSelect('tbody');
    tbody.first().addClass('list');
    tbl2.first().replaceContent(tbl.first().innerHTML+tbl2.first().innerHTML);
    tbl.first().remove();
    
    if(tbl2.length > 0) {
      var fuzzyOptions = {
        searchClass: "search-fuzzy", location: 0, distance: 100,
        threshold: 0.4, multiSearch: true
      };
      var pagingOptions = {
        pagingClass: "topPaging", innerWindow: 1, left: 1, right: 1 }
      var options = {
        valueNames: thNames,
        //page: 8,
        plugins: [
          //[ 'paging', pagingOptions ],
          //[ 'fuzzySearch', fuzzyOptions ]
        ]
      };
      //fuz = $(qnotesBox).elmsByAttribute('class', 'search-fuzzy', 'input');
      //fuz.addClass('search');
      var dirlst = new List('todolist', options);
      //fuz.first().onkeyup = function(e) { dirlst.fuzzySearch(this.value); };
    }
  }


  // Init Qnotes forms
  AsyncByPost = function() {
    frms = $(qnotesBox).elmsByTag('form'); if(frms.length < 1) { return; }
    frm1 = $(frms).first();
    // Login form
    if(frm1['authpw']) { $(qnotesBox).Login(frm1); }
    // Todo
    if(frm1['todoform']) { VSToDoAdd(frm1); }
    // XTodo
    if(frm1.hasClass('xtodo')) { ToDoFrm(frm1); }
    
    frm1.onsubmit = function() { return false; }
  }

  
  Qnotes.Init.qnoteext.push(AsyncByPost);
  Qnotes.Init.qnoteext.push(MiniboxInit);
  Qnotes.Init.qnoteext.push(SortTblInit);
  Qnotes.Init.qnoteext.push(TblSortInit);
  Qnotes.Init.qnoteext.push(ListJs);
  Qnotes.Init.qnoteext.push(PreCode);
  //Qnotes.Init.qnoteext.push(PreCodeH);
  //Qnotes.Init.qnoteext.push(Hljs);
  //Qnotes.Init.qnoteext.push(Prettify);
  Qnotes.Init.qnoteext.push(ToDoListJs);
  //Qnotes.Init.qnoteext.push(ToDoFrm);
  //Qnotes.Init.qnoteext.push(VSToDoAdd);

  // Back button  
  if ("onpopstate" in window) { window.onpopstate = HashChange; }
  $(qnotesBox).relayEvent("mouseup", "a.back:first", GoBack);
  Qnotes.Init.qnoteext.push(Back); AFLN();

  QnSetVPHt();
  window.onresize = function() { QnSetVPHt(); DOMAssistant.Qnotes.ResetPos(); Qnotes.item.triggerEvent("mousedown"); }
  
}

Qnotes.Ready.push(Ready1);
/*]]>*/
