/*<![CDATA[*/

Qnotes = window.Qnotes || {};
if(typeof Qnotes.Ready == "undefined") { Qnotes.Ready = []; }

  if (String.prototype.trim === undefined) {
  String.prototype.trim = function(){ return this.replace(/^\s+/, '').replace(/\s+$/, '') } };
  String.prototype.ucfirst = function() { return this.charAt(0).toUpperCase() + this.substring(1); }

  qnotelink = function(e) {
    var obj = $(e.target); if(obj.tagName == 'SPAN') { obj = obj.parentNode; }
    obj.onclick = function() { return false; }; if(!obj.href) { return false; }
    if(obj.href.indexOf('nolink') > -1) { return false; }
    Qnotes.item.title = obj.title; Qnotes.item.href = obj.href;
    Qnotes.item.triggerEvent("mousedown"); return false;
  }
  RALD = function (refresh, delay, type) {
    if(typeof type == 'undefined') { type = ''; } lnode = Qnotes.item;
    if(type == 'lnode') { lnode = Qnotes.Active.lnode; }
    if(refresh == 1) { n = Qnotes.Init.getnode(qnpagename, lnode.title, 'node'); if(n) n.remove(); }
    delay = (delay > 0) ? delay : 100; Qnotes.Url.fmt = 1;
    setTimeout(function() { lnode.triggerEvent("mousedown"); }, delay);
  }
  isQNL = function () {
    ql = $(qnotesBox).elmsByAttribute('class', 'qnotelink', 'div');
    if(ql.length > 0) { return true; } else { return false; }
  }
  UpdateQNT = function (qnp, qn, delay) {
    n = Qnotes.Init.getnode(qnp, qn, 'text');
    qtext = $(qnotesBox).elmsByAttribute('class', 'text', 'div').first();
    delay = (delay > 0) ? delay : 100;
    setTimeout(function() { n.innerHTML = qtext.innerHTML; }, delay);
  }
  phplmList = function(e) {
    var first = $(e.target).elmsByTag('ul').first(); if(first) { var s = first.style;
    if(s.display == "block") { s.display = "none"; } else { s.display = "block"; } }
  }

  AsyncSuccess = function(rdata, str) {
    if (DOMAssistant.AJAX.getStatus() ==  200 &&
        DOMAssistant.AJAX.getReadyState() == 4)
    {
      Qnotes.Loading.hide();
      if(str && str.length > 0 && rdata.indexOf(str) == -1) { return false; }
      return true;
    } return false;
  }
  
  function getLocalDateStamp(t, opt) {
    var temp = new Date(t);
    var t1 = padStr(temp.getFullYear())
                  + padStr(1 + temp.getMonth())
                  + padStr(temp.getDate());
    var t2 = padStr(temp.getHours())
                  + padStr(temp.getMinutes());
    var t3 = padStr(temp.getSeconds());
    var t4 = padStr(temp.getMilliseconds());
    if(opt == 2) return t1+t2;
    if(opt == 3) return t1+t2+t3;
    if(opt == 4) return t1+t2+t3+t4;
    return t1;
  }
  function padStr(i) {
    return (i < 10) ? "0" + i : "" + i;
  }

HashChange = function(e) {
  qnp = qnpagename; qn = window.location.hash.replace('#','');
  if(qn == 'nolink') { return; }
  var stateObj = { qnp: qnpagename, qn: qn };  //replaceState/pushState
  history.replaceState(stateObj, "Notebook", '#'+qn);
  if(Qnotes.Event !== '') { Qnotes.Event = ''; return; }
  if(Back.hash && Back.hash.length > 2) {
    if(Qnotes.backlink) { Qnotes.backlink.triggerEvent("mouseup"); }
  } else {
    if(e.state && e.state.qn && e.state.qnp) {
     Qnotes.eState =  1;
     Qnotes.backlink.href = qnscripturl+"?n="+qncurpgn+"?qnp="+e.state.qnp+"&qn="+e.state.qn;
     Qnotes.backlink.triggerEvent("mouseup");
    } else {
      if(window.location.hash) { Qnotes.List.triggerbytitle('', window.location.hash.replace('#','')); }
    }
  } Qnotes.Event = '';
}
Back = function() { Qnotes.eState = '';
  if(typeof Back.hash == 'undefined') { Back.hash = []; }
  qnp = qnpagename; qn = window.location.hash.replace('#','');
  Back.hash.push(qnscripturl+"?n="+qncurpgn+"&qnp="+qnp+"&qn="+qn);
  if(Back.hash.length > 15) { Back.hash.shift(); }; MBB();
}
MBB = function() {
  var h3 = $(qnotesBox).elmsByAttribute('class', 'fheading', 'h3');
  b = '<a class="back" href="#" title="">&#8592;</a>&nbsp;';
  if(h3.length > 0) { h3.first().innerHTML = b+h3.first().innerHTML; }
    else { $(qnotesBox).innerHTML = b+$(qnotesBox).innerHTML; }
  var _qbb = $(qnotesBox).elmsByAttribute('class', 'back', 'a');
  Qnotes.backlink = _qbb.first(); Qnotes.backlink.addClass(' qnote');
}
GoBack = function(e) { obj = $(e.target);
  obj.onclick = function() { return false; };
  if(Qnotes.eState == 1) { return; }; Qnotes.eState = 0;
  if(Back.hash.length > 1) { Back.hash.pop(); prev = Back.hash.pop(); }
    else { this.removeClass('qnote'); return; }
  obj.href = (typeof prev == 'undefined') ? Back.hash[0] : prev;
}

AFLN = function() {
  if(window.location.hash) { title = window.location.hash.replace('#',''); }
    else { title = Qnotes.List.l0.cssSelect('a.phplm').first().title; }
  setTimeout(function() {
    DOMAssistant.Qnotes.ResetPos(); Qnotes.List.triggerbytitle('', title); }, 500);
}

QnSetVPHt = function() {
  vp = Qnotes.ViewPane['vp0']; p = vp.parentNode;
  $(vp).style.height = window.innerHeight-162+'px';
  p.style.height = window.innerHeight-162+75+'px';

  list1 = document.getElementById('qnotesList1-wrapper');
  curPgs = document.getElementById('curPgs-wrapper');

  if(window.innerWidth <= 760) {
    $(list1).parentNode.style.height = window.innerHeight-162-60+'px';
    $(curPgs).parentNode.style.height = window.innerHeight-162-60+'px';
  } else {
    $(list1).parentNode.style.height = window.innerHeight-162+22+'px';
    $(curPgs).parentNode.style.height = window.innerHeight-162+22+'px';
  }
  $(list1).parentNode.style.display = 'block';
  $(curPgs).parentNode.style.display = 'none';

  var grs = $(list1).parentNode.parentNode;
  var pgs = curPgs.parentNode.parentNode;
  var t1 = $(grs).elmsByTag('div').first();
  var t2 = $(pgs).elmsByTag('div').first();
  var t = function() {
    qnotesToggleDisplay($(list1).parentNode);
    $(list1).style.display = 'block';
    qnotesToggleDisplay($(curPgs).parentNode);
    $(curPgs).style.display = 'block';
  }
  t1.onclick = function (e) {
    DOMAssistant.cancelBubble(e); t(); return false;
  }
  t2.onclick = function (e) {
    DOMAssistant.cancelBubble(e); t(); return false;
  }
}

/*]]>*/
